clc;clear all;

load pidraws_bc.mat;
pi_bc = data; clear data;

load pidraws_var.mat;
pi_var = data; clear data;

[nsim nvar2] = size(pi_bc); nvar = sqrt(nvar2);
rk = 1; % cointegration rank
%nsim = 75000;

apost_bc = [];
apost_var = [];

bpost_bc = [];
bpost_var = [];

t2_bc = [];
t2_var = [];

for jj = 1:nsim;
    pimat_bc = reshape(pi_bc(jj,:),nvar,nvar);
    [u,s,v] = svd(pimat_bc);

	alpha_bc = u(1:rk,1:rk)*s(1:rk,1:rk)*[v(1:rk,1:rk)' v(rk+1:nvar,1:rk)'];
	beta_bc = [eye(rk) [u(rk+1:nvar,1:rk)*inv(u(1:rk,1:rk))]'];

    pimat_var = reshape(pi_var(jj,:),nvar,nvar);
    [u,s,v] = svd(pimat_var);

	alpha_var = u(1:rk,1:rk)*s(1:rk,1:rk)*[v(1:rk,1:rk)' v(rk+1:nvar,1:rk)'];
	beta_var = [eye(rk) [u(rk+1:nvar,1:rk)*inv(u(1:rk,1:rk))]'];

    b_bc = beta_bc/sqrt(beta_bc*beta_bc');
    b_var = beta_var/sqrt(beta_var*beta_var');
    
    [vecs vals] = eig(b_bc'*b_bc);
    [junk vcol] = max(diag(vals));
    bpost_bc = [bpost_bc; vecs(:,vcol)'];
    t2_bc = [t2_bc; (1-max(diag(vals)))/(nvar-1)*nvar];
    
    [vecs vals] = eig(b_var'*b_var);
    [junk vcol] = max(diag(vals));
    bpost_var = [bpost_var; vecs(:,vcol)'];
    t2_var = [t2_var; (1-max(diag(vals)))/(nvar-1)*nvar];
    
    apost_bc = [apost_bc; alpha_bc*sqrt(beta_bc*beta_bc')];
    apost_var = [apost_var; alpha_var*sqrt(beta_var*beta_var')];
    
end
lw = zeros(nsim,1);
[x1b,y1b] = smooth(lw,bpost_bc(:,1));
[x1v,y1v] = smooth(lw,bpost_var(:,1));

[x2b,y2b] = smooth(lw,bpost_bc(:,2));
[x2v,y2v] = smooth(lw,bpost_var(:,2));

[x3b,y3b] = smooth(lw,bpost_bc(:,3));
[x3v,y3v] = smooth(lw,bpost_var(:,3));

[x4b,y4b] = smooth(lw,bpost_bc(:,4));
[x4v,y4v] = smooth(lw,bpost_var(:,4));

[x5b,y5b] = smooth(lw,bpost_bc(:,5));
[x5v,y5v] = smooth(lw,bpost_var(:,5));

[x6b,y6b] = smooth(lw,bpost_bc(:,6));
[x6v,y6v] = smooth(lw,bpost_var(:,6));

figure;
plot(x1b,y1b,x2b,y2b,x3b,y3b,x4b,y4b,x5b,y5b,x6b,y6b);
% plot(x1b,y1b,x1v,y1v);
figure;
plot(x1v,y1v,x2v,y2v,x3v,y3v,x4v,y4v,x5v,y5v,x6v,y6v);
% plot(x2b,y2b,x2v,y2v);
% figure;
% plot(x3b,y3b,x3v,y3v);
% figure;
% plot(x4b,y4b,x4v,y4v);
% figure;
% plot(x5b,y5b,x5v,y5v);
% figure;
% plot(x6b,y6b,x6v,y6v);

[mean([t2_bc t2_var]); std([t2_bc t2_var])]

        


    
