/* This program is for censoring the simulated data using the BBQ algorithm  */
/* The dating code adapted from code provided by Don Harding and Adrian Pagan*/
new; cls;

#include bbqdh.src;

nsim = 600; 
nobs =168; 
nov = 6;
ms = 0;

if ms ==1;
inname = "simulated_data\\simlevel_au_bc.txt"$|
"simulated_data\\simlevel_us_bc.txt"$|
"simulated_data\\simlevel_uk_bc.txt"$|
"simulated_data\\simlevel_ge_bc.txt"$|
"simulated_data\\simlevel_ca_bc.txt"$|
"simulated_data\\simlevel_jp_bc.txt";

outname = "simulated_data\\wt_au_bc.txt"$|
"simulated_data\\wt_us_bc.txt"$|
"simulated_data\\wt_uk_bc.txt"$|
"simulated_data\\wt_ge_bc.txt"$|
"simulated_data\\wt_ca_bc.txt"$|
"simulated_data\\wt_jp_bc.txt";
else;
inname = "simulated_data\\simlevel_au_var.txt"$|
"simulated_data\\simlevel_us_var.txt"$|
"simulated_data\\simlevel_uk_var.txt"$|
"simulated_data\\simlevel_ge_var.txt"$|
"simulated_data\\simlevel_ca_var.txt"$|
"simulated_data\\simlevel_jp_var.txt";

outname = "simulated_data\\wt_au_var.txt"$|
"simulated_data\\wt_us_var.txt"$|
"simulated_data\\wt_uk_var.txt"$|
"simulated_data\\wt_ge_var.txt"$|
"simulated_data\\wt_ca_var.txt"$|
"simulated_data\\wt_jp_var.txt";
endif;

jiter = 1;
do while jiter <= nov;

strin = inname[jiter];
strout = outname[jiter];

load xx[nsim,nobs] = ^strin;


k_ets = 0; /* determines the number of observations before t that are passed to ets()  */
k_cts = 0;/* determines the number of observations after t that passed to ets() */
	      /*  k=2 => BBQ; k=0 => Okun */
l_ets  =2;/* determines the number of observations after t that are passed to cts() in the z vector     */
l_cts  =2;/* determines the number of observations before t that are passed to ets() in the z vector     */
a_ets={};/* a vector of parrameters that is passed to the  ets procedure     */
a_cts = {};/* a vector of parrameters that is passed to the  cts procedure */
ypt_sum=zeros(4,nsim);
ytp_sum= zeros(4,nsim);
Stmat = zeros(nobs,nsim);

p_t = zeros(nsim,6);
t_p = zeros(nsim,6);
start = hsec;

jj = 1;
do while jj <= nsim;

y = 100*xx[jj,1:nobs]' ;

/* JAPE THIS TO AUT STATE MATRICES (FOR CONCORDANCE STATS) */
{peaks, troughs, state} = findates(&ets_bbq,&cts_bbq,y,k_ets,k_cts,l_ets,l_cts,a_ets,a_cts);
Stmat[.,jj] = state;

z_peaks =seqa(1,1,rows(peaks));
z_peaks = selif(  z_peaks,peaks);
z_troughs =seqa(1,1,rows(troughs));
z_troughs = selif(  z_troughs,troughs);

d = zeros(rows(state),1);

if state[1,1] ==1 ;
d[1,1] = 1;
else;
d[1,1] = -1;
endif;
ii = 1;
do while ii <= rows(state);
    if state[ii,1] ==1 ;
        if state[ii-1,1] ==1;
            d[ii,1] = d[ii-1,1] +1;
        else ;
            d[ii,1] = 1;
        endif;
    elseif state[ii,1] == -1 ;
        if state[ii-1,1] == -1;
            d[ii,1] = d[ii-1,1] -1;
        else ;
            d[ii,1] = -1;
        endif;
    endif;

    ii = ii+1;
endo;

@ SUMMARY STATS @
if ((sumc(peaks) > 1) and (sumc(troughs) > 0)) or  ((sumc(peaks) > 0) and (sumc(troughs) > 1));
{pt_stats, tp_stats, pt_long, tp_long} =summary_stats(z_peaks,z_troughs,y,d);
p_t[jj,.] = meanc(pt_stats)' ;
t_p[jj,.] = meanc(tp_stats)' ;
else;
p_t[jj,.] = zeros(1,6) ;
t_p[jj,.] = zeros(1,6) ;
endif;
jj = jj+1;
endo;

(hsec-start)/100;


screen off;
output file = ^strout reset;
vec(Stmat);
output off;

jiter = jiter+1;
endo;
screen on;

