%For calulating concordance and correlation statistics

clc; clear all;
nsim = 600;
nobs = 168;

country1 = 'us';
country2 = 'ge';
model = 'var';

% values in wt_XX_var.txt and wt_XX_bc.txt  are: 1 (expansion), 0 (recession), or -1 (uncertain). 
% Set the value of 'SetUncertainDatesTo' to allocate these to expansions or recessions. This
% is optional -- set to -1 to leave as is, but in this case the 'recession probabilities' may exceed 1.
SetUncertainDatesTo = 0;  

filename = ['simulated_data\wt_' country1 '_' model '.txt'];
load (filename);
file1 = ['wt_' country1 '_' model ];
wt1 = eval(file1); clear(file1);
Stmat = reshape(wt1',nsim,nobs)';
Stmat(find(Stmat<0))=SetUncertainDatesTo;
S_1 = Stmat;


filename = ['simulated_data\wt_' country2 '_' model '.txt'];
load (filename);
file2 = ['wt_' country2 '_' model ];
wt2 = eval(file2); clear(file2);
Stmat = reshape(wt2',nsim,nobs)';
Stmat(find(Stmat<0))=SetUncertainDatesTo;
S_2 = Stmat;

IR = zeros(nsim,2);
for i=1:nsim;
    St = [S_1(:,i) S_2(:,i)];
        for j=1:cols(St)-1;
                col1 = St(:,1); col2 = St(:,j+1);    
        if j==1
            alltmp = [col1 col2];
        else
            alltmp = [alltmp col2];
        end
                tmp = [col1 col2]; 
        [Ihat, rho] = synch(tmp);
          IR(i,:) = [Ihat rho];          
    end;
end;

% Draws that don't pass the 'reality check' set
% up in the data simulation programs simdata_var.m and simdata_msvar.m are excluded. 

fileext = ['simulated_data\reality_vector_' model '.txt'];
load (fileext);
reality_vector = eval(['reality_vector_' model]);
clear(fileext);
valid_au = reality_vector(:,1);
valid_us = reality_vector(:,2);
valid_uk = reality_vector(:,3);
valid_ge = reality_vector(:,4);
valid_ca = reality_vector(:,5);
valid_jp = reality_vector(:,6);
valid_1 = eval(['valid_' country1]);
valid_2 = eval(['valid_' country2]);  
IR = selif(IR, valid_1.*valid_2);

IR = selif(IR,IR(:,2)~=-2);
Ihat = IR(:,1);
rho = IR(:,2);
[mean(IR);std(IR)]

filename1 = ['simulated_data\c_' country1 '_' country2 '_' model '.txt'];
filename2 = ['simulated_data\r_' country1 '_' country2  '_' model '.txt'];

save(filename1,'Ihat','-ASCII')
save(filename2,'rho','-ASCII')


